"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RabbitModule = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _err = _interopRequireDefault(require("@lskjs/err"));
var _module = _interopRequireDefault(require("@lskjs/module"));
var _maskUriPassword = _interopRequireDefault(require("@lskjs/utils/maskUriPassword"));
var _amqplib = _interopRequireDefault(require("amqplib"));
var _bluebird = _interopRequireDefault(require("bluebird"));
var _events = _interopRequireDefault(require("events"));
var _get3 = _interopRequireDefault(require("lodash/get"));
var _omit = _interopRequireDefault(require("lodash/omit"));
var _objectHash = _interopRequireDefault(require("object-hash"));
var _startGoProc = _interopRequireDefault(require("./startGoProc"));
var _promiseWithTimeout = require("./utils/promiseWithTimeout");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var serializeData = function serializeData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (typeof data === 'string') return data;
  return JSON.stringify(data);
};
var noop = function noop() {
  //
};
var RabbitModule = /*#__PURE__*/function (_Module) {
  (0, _inherits2["default"])(RabbitModule, _Module);
  var _super = _createSuper(RabbitModule);
  function RabbitModule() {
    var _this;
    (0, _classCallCheck2["default"])(this, RabbitModule);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.startGoProc = _startGoProc["default"];
    _this.config = {
      prefetch: 1,
      reconnectTimeout: 5000
    };
    _this.assertQueues = {};
    return _this;
  }
  (0, _createClass2["default"])(RabbitModule, [{
    key: "init",
    value: function () {
      var _init = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return (0, _get2["default"])((0, _getPrototypeOf2["default"])(RabbitModule.prototype), "init", this).call(this);
            case 2:
              this.enabled = !this.config.disabled;
              if (this.enabled) {
                _context.next = 5;
                break;
              }
              return _context.abrupt("return");
            case 5:
              this.emitter = new _events["default"]();
              if (!this.config.uri) {
                this.log.warn('!config.uri using localhost');
                this.config.uri = 'amqp://localhost';
              }
              this.log.debug('uri', (0, _maskUriPassword["default"])(this.config.uri));
              if (!this.config.queues) {
                this.log.warn('!config.queues');
              }
              this.queues = this.config.queues || {};
              this.exchanges = this.config.exchanges || {};
              this.goRabbitPath = this.config.goRabbit;
              this.isGoTransport = !!this.goRabbitPath;
              if (this.isGoTransport) {
                this.log.debug('using go lang transport', this.goRabbitPath);
              }
              this.tryReconnect = false;
            case 15:
            case "end":
              return _context.stop();
          }
        }, _callee, this);
      }));
      function init() {
        return _init.apply(this, arguments);
      }
      return init;
    }()
  }, {
    key: "createConnection",
    value: function () {
      var _createConnection = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
        var _ref,
          _ref$withoutListeners,
          withoutListeners,
          _this$config$socketOp,
          socketOptions,
          connection,
          _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _ref = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {}, _ref$withoutListeners = _ref.withoutListeners, withoutListeners = _ref$withoutListeners === void 0 ? false : _ref$withoutListeners;
              _this$config$socketOp = this.config.socketOptions, socketOptions = _this$config$socketOp === void 0 ? {} : _this$config$socketOp;
              _context2.next = 4;
              return _amqplib["default"].connect(this.config.uri, _objectSpread({
                timeout: 10000
              }, socketOptions));
            case 4:
              connection = _context2.sent;
              if (!withoutListeners) {
                connection.once('error', this.onError.bind(this));
                connection.once('close', this.onError.bind(this));
              }
              return _context2.abrupt("return", connection);
            case 7:
            case "end":
              return _context2.stop();
          }
        }, _callee2, this);
      }));
      function createConnection() {
        return _createConnection.apply(this, arguments);
      }
      return createConnection;
    }()
  }, {
    key: "connect",
    value: function () {
      var _connect = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
        var prefetchCount;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              this.log.trace('connecting', (0, _maskUriPassword["default"])(this.config.uri));
              _context3.next = 3;
              return this.createConnection();
            case 3:
              this.listenConnection = _context3.sent;
              _context3.next = 6;
              return this.createConnection();
            case 6:
              this.sendConnection = _context3.sent;
              _context3.next = 9;
              return this.listenConnection.createChannel();
            case 9:
              this.listenChannel = _context3.sent;
              _context3.next = 12;
              return this.sendConnection.createConfirmChannel();
            case 12:
              this.sendChannel = _context3.sent;
              this.onOpen();
              prefetchCount = (0, _get3["default"])(this.config, 'options.prefetch');
              if (prefetchCount) {
                // TODO: подумать тут ли это оставлять?
                this.listenChannel.prefetch(prefetchCount);
              }
              if (this.isGoTransport) {
                this.startGoProc();
              }
              this.log.debug('connected');
              this.emit('connected');
            case 19:
            case "end":
              return _context3.stop();
          }
        }, _callee3, this);
      }));
      function connect() {
        return _connect.apply(this, arguments);
      }
      return connect;
    }()
  }, {
    key: "run",
    value: function () {
      var _run = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              if (this.enabled) {
                _context4.next = 2;
                break;
              }
              return _context4.abrupt("return");
            case 2:
              _context4.next = 4;
              return (0, _get2["default"])((0, _getPrototypeOf2["default"])(RabbitModule.prototype), "run", this).call(this);
            case 4:
              _context4.prev = 4;
              _context4.next = 7;
              return this.connect();
            case 7:
              _context4.next = 13;
              break;
            case 9:
              _context4.prev = 9;
              _context4.t0 = _context4["catch"](4);
              _context4.next = 13;
              return this.onError(_context4.t0);
            case 13:
            case "end":
              return _context4.stop();
          }
        }, _callee4, this, [[4, 9]]);
      }));
      function run() {
        return _run.apply(this, arguments);
      }
      return run;
    }()
  }, {
    key: "onOpen",
    value: function onOpen() {}
  }, {
    key: "restart",
    value: function () {
      var _restart = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              _context5.prev = 0;
              _context5.next = 3;
              return this.cancel();
            case 3:
              _context5.next = 5;
              return this.stop();
            case 5:
              _context5.next = 7;
              return this.connect();
            case 7:
              this.tryReconnect = false;
              _context5.next = 14;
              break;
            case 10:
              _context5.prev = 10;
              _context5.t0 = _context5["catch"](0);
              _context5.next = 14;
              return this.onError(_context5.t0);
            case 14:
            case "end":
              return _context5.stop();
          }
        }, _callee5, this, [[0, 10]]);
      }));
      function restart() {
        return _restart.apply(this, arguments);
      }
      return restart;
    }() // debouncedOnError = debounce(this.onError, 1);
  }, {
    key: "onError",
    value: function () {
      var _onError = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(err) {
        var _this2 = this;
        var reconnectTimeout;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) switch (_context6.prev = _context6.next) {
            case 0:
              if (err) {
                _context6.next = 2;
                break;
              }
              return _context6.abrupt("return");
            case 2:
              if (!this.tryReconnect) {
                _context6.next = 4;
                break;
              }
              return _context6.abrupt("return");
            case 4:
              this.tryReconnect = true;
              this.emit('connectionError');
              this.log.error('[onError]', err);
              if (_err["default"].getCode(err) === 'Unexpected close') {
                setTimeout(function () {
                  _this2.log.fatal('[ALARM]', 'PROCESS.KILL in 5 sec', err);
                  process.kill(1);
                }, 5000);
              }
              reconnectTimeout = this.config.reconnectTimeout;
              this.log.debug("error, wait ".concat(reconnectTimeout, " ms for restart connect"));
              _context6.next = 12;
              return _bluebird["default"].delay(reconnectTimeout);
            case 12:
              this.restart();
            case 13:
            case "end":
              return _context6.stop();
          }
        }, _callee6, this);
      }));
      function onError(_x) {
        return _onError.apply(this, arguments);
      }
      return onError;
    }()
  }, {
    key: "ack",
    value: function () {
      var _ack = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(msg) {
        var _ref2,
          allUpTo,
          _args7 = arguments;
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) switch (_context7.prev = _context7.next) {
            case 0:
              _ref2 = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : {}, allUpTo = _ref2.allUpTo;
              return _context7.abrupt("return", this.listenChannel.ack(msg, allUpTo));
            case 2:
            case "end":
              return _context7.stop();
          }
        }, _callee7, this);
      }));
      function ack(_x2) {
        return _ack.apply(this, arguments);
      }
      return ack;
    }()
  }, {
    key: "nack",
    value: function () {
      var _nack = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(msg) {
        var _ref3,
          allUpTo,
          requeue,
          _args8 = arguments;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) switch (_context8.prev = _context8.next) {
            case 0:
              _ref3 = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : {}, allUpTo = _ref3.allUpTo, requeue = _ref3.requeue;
              return _context8.abrupt("return", this.listenChannel.nack(msg, allUpTo, requeue));
            case 2:
            case "end":
              return _context8.stop();
          }
        }, _callee8, this);
      }));
      function nack(_x3) {
        return _nack.apply(this, arguments);
      }
      return nack;
    }()
  }, {
    key: "parse",
    value: function () {
      var _parse = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9() {
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) switch (_context9.prev = _context9.next) {
            case 0:
              throw new _err["default"]('not implemented worker.parse()');
            case 1:
            case "end":
              return _context9.stop();
          }
        }, _callee9);
      }));
      function parse() {
        return _parse.apply(this, arguments);
      }
      return parse;
    }()
  }, {
    key: "queue",
    value: function queue(rawQueue) {
      // NOTE: deprecated
      return rawQueue;
      // const queueName = this.getQueueName(rawQueue);
      // if (!queueName) throw new Err('rabbit.queueNotFound', { data: { queueName } });
      // await this.assertQueueOnce(queueName);
      // return rawQueue;
    }
  }, {
    key: "getQueueName",
    value: function getQueueName(rawQueue) {
      var queueName = rawQueue;
      if (!rawQueue) {
        throw new _err["default"]('!rawQueue', {
          rawQueue: rawQueue
        });
      } else if (typeof rawQueue === 'string') {
        queueName = rawQueue;
      } else {
        queueName = rawQueue.name || rawQueue.queue;
      }
      var res = this.queues[queueName] ? this.queues[queueName].queue : queueName;
      // TODO: WHY prefix_prefix_prefix_prefix_order_list
      // TODO: remove this KOSTYL'!!
      if (this.config.prefix && !res.startsWith(this.config.prefix)) res = this.config.prefix + res;
      return res;
    }
  }, {
    key: "getQueueParams",
    value: function getQueueParams(rawQueue) {
      // const queueName = this.getQueueName(rawQueue);
      if (this.queues[rawQueue]) return this.queues[rawQueue];
      return {
        queue: this.getQueueName(rawQueue)
      };
    }
  }, {
    key: "assertQueueOnce",
    value: function () {
      var _assertQueueOnce = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(rawQueue) {
        var res;
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) switch (_context10.prev = _context10.next) {
            case 0:
              if (!this.assertQueues[rawQueue]) {
                _context10.next = 2;
                break;
              }
              return _context10.abrupt("return", null);
            case 2:
              this.assertQueues[rawQueue] = new Date();
              _context10.next = 5;
              return this.assertQueue(rawQueue);
            case 5:
              res = _context10.sent;
              return _context10.abrupt("return", res);
            case 7:
            case "end":
              return _context10.stop();
          }
        }, _callee10, this);
      }));
      function assertQueueOnce(_x4) {
        return _assertQueueOnce.apply(this, arguments);
      }
      return assertQueueOnce;
    }()
  }, {
    key: "assertQueue",
    value: function () {
      var _assertQueue = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee11(rawQueue) {
        var queueName, options, res;
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) switch (_context11.prev = _context11.next) {
            case 0:
              queueName = this.getQueueName(rawQueue); // console.log({ queue, queueName });
              if (queueName) {
                _context11.next = 4;
                break;
              }
              this.log.error('!queueName', {
                rawQueue: rawQueue,
                queueName: queueName
              });
              throw new _err["default"]('!queueName', {
                rawQueue: rawQueue,
                queueName: queueName
              });
            case 4:
              options = (0, _get3["default"])(this.config, 'options');
              this.log.trace("assertQueue(".concat(queueName, ")"), (0, _omit["default"])(options, ['prefetch']));
              _context11.next = 8;
              return this.listenChannel.assertQueue(queueName, options);
            case 8:
              res = _context11.sent;
              return _context11.abrupt("return", res);
            case 10:
            case "end":
              return _context11.stop();
          }
        }, _callee11, this);
      }));
      function assertQueue(_x5) {
        return _assertQueue.apply(this, arguments);
      }
      return assertQueue;
    }()
  }, {
    key: "assertExchange",
    value: function assertExchange(exchange) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'direct';
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      this.log.trace("assertExchange(".concat(exchange, ", ").concat(type, ")"), (0, _omit["default"])(options, ['prefetch']));
      return this.listenChannel.assertExchange(exchange, type, options);
    }
  }, {
    key: "publish",
    value: function () {
      var _publish = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee12(exchange, key, msg) {
        var options,
          channel,
          row,
          _args12 = arguments;
        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) switch (_context12.prev = _context12.next) {
            case 0:
              options = _args12.length > 3 && _args12[3] !== undefined ? _args12[3] : {};
              channel = _args12.length > 4 && _args12[4] !== undefined ? _args12[4] : this.sendChannel;
              row = serializeData(msg);
              return _context12.abrupt("return", new _bluebird["default"](function (res, rej) {
                channel.publish(exchange, key, Buffer.from(row), options, function (err, ok) {
                  if (err) {
                    rej(err);
                  } else {
                    res(ok);
                  }
                });
              }));
            case 4:
            case "end":
              return _context12.stop();
          }
        }, _callee12, this);
      }));
      function publish(_x6, _x7, _x8) {
        return _publish.apply(this, arguments);
      }
      return publish;
    }()
  }, {
    key: "bindQueue",
    value: function bindQueue(queue, source, pattern) {
      var _this$listenChannel;
      for (var _len2 = arguments.length, args = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
        args[_key2 - 3] = arguments[_key2];
      }
      return (_this$listenChannel = this.listenChannel).bindQueue.apply(_this$listenChannel, [queue, source, pattern].concat(args));
    }
  }, {
    key: "sendToQueue",
    value: function () {
      var _sendToQueue = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee13(rawQueue, data, options) {
        var channel,
          queueName,
          queueParams,
          mergedOptions,
          _args13 = arguments;
        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) switch (_context13.prev = _context13.next) {
            case 0:
              channel = _args13.length > 3 && _args13[3] !== undefined ? _args13[3] : this.sendChannel;
              queueName = this.getQueueName(rawQueue);
              queueParams = this.getQueueParams(rawQueue);
              _context13.next = 5;
              return this.assertQueueOnce(queueName);
            case 5:
              mergedOptions = _objectSpread(_objectSpread(_objectSpread({}, (0, _get3["default"])(this, 'config.queueOptions', {})), queueParams.options || {}), options);
              return _context13.abrupt("return", new _bluebird["default"](function (res, rej) {
                var row = serializeData(data);
                channel.sendToQueue(queueName, Buffer.from(row), mergedOptions, function (err, ok) {
                  if (err) {
                    rej(err);
                  } else {
                    res(ok);
                  }
                });
              }));
            case 7:
            case "end":
              return _context13.stop();
          }
        }, _callee13, this);
      }));
      function sendToQueue(_x9, _x10, _x11) {
        return _sendToQueue.apply(this, arguments);
      }
      return sendToQueue;
    }()
  }, {
    key: "sendToQueueNative",
    value: function () {
      var _sendToQueueNative = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee15(rawQueue, data) {
        var _this3 = this;
        var queueName, debug, taskHash, row, proc;
        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) switch (_context15.prev = _context15.next) {
            case 0:
              queueName = this.getQueueName(rawQueue);
              debug = this.config.debug || false; // const rows = serializeDataArray(data);
              taskHash = "".concat((0, _objectHash["default"])(JSON.parse(JSON.stringify({
                queueName: queueName,
                data: data
              }))), "_").concat(Date.now(), "_").concat(Math.random(), "}");
              row = JSON.stringify({
                queue: queueName,
                hash: taskHash,
                content: serializeData(data)
              });
              if (debug) {
                this.log.trace('[RM] sendToQueueNative', queueName, row.substr(0, 30));
              }
              proc = this.proc;
              proc.stdin.write(row);
              proc.stdin.write('\n');
              // this.log.trace('--------WRITE-----');
              // this.log.trace(row);
              // this.log.trace('/--------WRITE-----/');
              _context15.next = 10;
              return new Promise(function (resolve) {
                _this3.emitter.once('close', /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee14() {
                  return _regenerator["default"].wrap(function _callee14$(_context14) {
                    while (1) switch (_context14.prev = _context14.next) {
                      case 0:
                        if (debug) {
                          _this3.log.trace('[RM] reject', row);
                        }
                        _context14.next = 3;
                        return _bluebird["default"].delay(1000);
                      case 3:
                        return _context14.abrupt("return", _this3.sendToQueueNative(queueName, data).then(resolve));
                      case 4:
                      case "end":
                        return _context14.stop();
                    }
                  }, _callee14);
                })));
                _this3.emitter.once(taskHash, function () {
                  resolve();
                });
              });
            case 10:
            case "end":
              return _context15.stop();
          }
        }, _callee15, this);
      }));
      function sendToQueueNative(_x12, _x13) {
        return _sendToQueueNative.apply(this, arguments);
      }
      return sendToQueueNative;
    }()
  }, {
    key: "consume",
    value: function () {
      var _consume = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee16(rawQueue, callback) {
        var initOptions,
          queueName,
          options,
          data,
          _args16 = arguments;
        return _regenerator["default"].wrap(function _callee16$(_context16) {
          while (1) switch (_context16.prev = _context16.next) {
            case 0:
              initOptions = _args16.length > 2 && _args16[2] !== undefined ? _args16[2] : {};
              _context16.next = 3;
              return this.assertQueueOnce(rawQueue);
            case 3:
              queueName = this.getQueueName(rawQueue);
              options = _objectSpread(_objectSpread({}, this.config.options || {}), initOptions);
              if (options.prefetch) {
                _context16.next = 8;
                break;
              }
              this.log.warn("[".concat(queueName, "] prefetch == 0, rabbit.consume ignore"));
              return _context16.abrupt("return", null);
            case 8:
              this.log.info("consume(".concat(queueName, ")"), options);
              _context16.next = 11;
              return this.listenChannel.consume(queueName, callback, options);
            case 11:
              data = _context16.sent;
              this.consumerTag = data.consumerTag;
              return _context16.abrupt("return", data);
            case 14:
            case "end":
              return _context16.stop();
          }
        }, _callee16, this);
      }));
      function consume(_x14, _x15) {
        return _consume.apply(this, arguments);
      }
      return consume;
    }()
  }, {
    key: "cancel",
    value: function () {
      var _cancel = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee17() {
        return _regenerator["default"].wrap(function _callee17$(_context17) {
          while (1) switch (_context17.prev = _context17.next) {
            case 0:
              _context17.prev = 0;
              _context17.next = 3;
              return this.listenChannel.cancel(this.consumerTag);
            case 3:
              _context17.next = 7;
              break;
            case 5:
              _context17.prev = 5;
              _context17.t0 = _context17["catch"](0);
            case 7:
            case "end":
              return _context17.stop();
          }
        }, _callee17, this, [[0, 5]]);
      }));
      function cancel() {
        return _cancel.apply(this, arguments);
      }
      return cancel;
    }()
  }, {
    key: "stop",
    value: function () {
      var _stop = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee18() {
        return _regenerator["default"].wrap(function _callee18$(_context18) {
          while (1) switch (_context18.prev = _context18.next) {
            case 0:
              _context18.prev = 0;
              _context18.next = 3;
              return this.listenChannel.close();
            case 3:
              _context18.next = 7;
              break;
            case 5:
              _context18.prev = 5;
              _context18.t0 = _context18["catch"](0);
            case 7:
              _context18.prev = 7;
              _context18.next = 10;
              return this.listenConnection.close();
            case 10:
              _context18.next = 14;
              break;
            case 12:
              _context18.prev = 12;
              _context18.t1 = _context18["catch"](7);
            case 14:
              _context18.prev = 14;
              _context18.next = 17;
              return this.sendChannel.close();
            case 17:
              _context18.next = 21;
              break;
            case 19:
              _context18.prev = 19;
              _context18.t2 = _context18["catch"](14);
            case 21:
              _context18.prev = 21;
              _context18.next = 24;
              return this.sendConnection.close();
            case 24:
              _context18.next = 28;
              break;
            case 26:
              _context18.prev = 26;
              _context18.t3 = _context18["catch"](21);
            case 28:
            case "end":
              return _context18.stop();
          }
        }, _callee18, this, [[0, 5], [7, 12], [14, 19], [21, 26]]);
      }));
      function stop() {
        return _stop.apply(this, arguments);
      }
      return stop;
    }()
  }, {
    key: "healthcheck",
    value: function () {
      var _healthcheck = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee20() {
        var _this4 = this;
        return _regenerator["default"].wrap(function _callee20$(_context20) {
          while (1) switch (_context20.prev = _context20.next) {
            case 0:
              return _context20.abrupt("return", (0, _promiseWithTimeout.promiseWithTimeout)( /*#__PURE__*/(0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee19() {
                var sendConnection, sendChannel;
                return _regenerator["default"].wrap(function _callee19$(_context19) {
                  while (1) switch (_context19.prev = _context19.next) {
                    case 0:
                      _context19.next = 2;
                      return _this4.createConnection({
                        withoutListeners: true
                      });
                    case 2:
                      sendConnection = _context19.sent;
                      sendConnection.once('close', noop);
                      sendConnection.once('error', noop);
                      _context19.next = 7;
                      return sendConnection.createConfirmChannel();
                    case 7:
                      sendChannel = _context19.sent;
                      sendChannel.once('close', noop);
                      sendChannel.once('error', noop);
                      // TODO не делать ассерт каждый раз
                      _context19.next = 12;
                      return sendChannel.assertQueue('healthcheck');
                    case 12:
                      _context19.next = 14;
                      return _this4.sendToQueue('healthcheck', {
                        random: Math.random()
                      }, {
                        expired: 24 * 60 * 60 * 1000
                      }, sendChannel);
                    case 14:
                      _context19.next = 16;
                      return sendChannel.close();
                    case 16:
                      _context19.next = 18;
                      return sendConnection.close();
                    case 18:
                      return _context19.abrupt("return", true);
                    case 19:
                    case "end":
                      return _context19.stop();
                  }
                }, _callee19);
              })), 15000));
            case 1:
            case "end":
              return _context20.stop();
          }
        }, _callee20);
      }));
      function healthcheck() {
        return _healthcheck.apply(this, arguments);
      }
      return healthcheck;
    }()
  }]);
  return RabbitModule;
}(_module["default"]);
exports.RabbitModule = RabbitModule;
var _default = RabbitModule;
exports["default"] = _default;
//# sourceMappingURL=RabbitModule.js.map