"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = startGoProc;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _child_process = require("child_process");
var _get = _interopRequireDefault(require("lodash/get"));
var paramsToArgs = function paramsToArgs() {
  var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return Object.keys(params).map(function (key) {
    return ["-".concat(key), params[key]].join(' ');
  });
};
var serializeData = function serializeData() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (typeof data === 'string') return data;
  return JSON.stringify(data);
};
var serializeDataArray = function serializeDataArray() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  if (Array.isArray(data)) {
    return data.map(serializeData);
  }
  return serializeData(data);
};
function startGoProc() {
  return _startGoProc.apply(this, arguments);
}
function _startGoProc() {
  _startGoProc = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
    var _this = this;
    var debug, uri, params, cmd, args, proc;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          // const { debug } = this.config;
          debug = this.config.debug || false;
          uri = this.config.uri;
          if (uri.includes('?')) {
            uri = (0, _get["default"])(uri.split('?'), '0');
          }
          params = {
            amqp: uri
          }; // const cmd = GO_RABBIT;
          cmd = this.goRabbitPath; // const cmd = `${GO_RABBIT}`;
          // const cmd = `echo '${row}' | node /Users/isuvorov/projects/parser-cloud/packages/parser-cloud/rabbit-node.js`;
          args = paramsToArgs(params);
          if (debug) {
            this.log.trace('[RM]', "".concat(cmd, " ").concat(args.join(' ')));
            // echo '{"_id": "5e91cc24001c9049700945bc", "videoId": "PRsKXb4e_Bo"}' | ./rabbit -queue z-dev-TEST
          }
          proc = (0, _child_process.spawn)(cmd, args, {
            shell: true
          });
          proc.stdout.on('data', function (chunk) {
            var strings = String(chunk).split('\n');
            strings.forEach(function (str) {
              if (debug) {
                _this.log.trace('[RM] stdout:', str);
              }
              try {
                var json = JSON.parse(String(str));
                if (json.type === 'response') {
                  _this.emitter.emit(json.hash, {
                    complete: json.complete
                  });
                }
              } catch (e) {
                // this.log.trace(String(chunk), 'не получилось');
                /* eslint no-empty: "error" */
              }
              // this.log.trace('----------------------');
            });
          });

          proc.stderr.on('data', function (chunk) {
            _this.log.error("[RM] stderr: ".concat(chunk));
          });
          proc.on('close', function () {
            if (debug) {
              _this.log.warn('что то пошло не так');
            }
            _this.emitter.emit('close');
            setTimeout(function () {
              _this.startGoProc();
            }, 100);
          });
          this.proc = proc;
        case 12:
        case "end":
          return _context.stop();
      }
    }, _callee, this);
  }));
  return _startGoProc.apply(this, arguments);
}
//# sourceMappingURL=startGoProc.js.map