"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.promiseWithTimeout = exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _err = require("@lskjs/err");
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
// import { isFunction } from '@lskjs/utils/isFunction';

var promiseWithTimeout = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(promiseOrFn) {
    var timeout,
      timeoutId,
      timeoutPromise,
      promise,
      res,
      _args = arguments;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          timeout = _args.length > 1 && _args[1] !== undefined ? _args[1] : 15000;
          timeoutPromise = new Promise(function (_, reject) {
            timeoutId = setTimeout(function () {
              reject(new _err.Err('PROMISE_TIMEOUT', {
                timeout: timeout
              }));
            }, timeout);
          });
          promise = (0, _isFunction["default"])(promiseOrFn) ? promiseOrFn() : promiseOrFn;
          _context.next = 5;
          return Promise.race([promise, timeoutPromise]);
        case 5:
          res = _context.sent;
          clearTimeout(timeoutId);
          return _context.abrupt("return", res);
        case 8:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return function promiseWithTimeout(_x) {
    return _ref.apply(this, arguments);
  };
}();
exports.promiseWithTimeout = promiseWithTimeout;
var _default = promiseWithTimeout;
exports["default"] = _default;
//# sourceMappingURL=promiseWithTimeout.js.map